import require$$0, { useState, useEffect, useCallback } from "react";
import styled, { keyframes } from "styled-components";
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = require$$0, k = Symbol.for("react.element"), l = Symbol.for("react.fragment"), m = Object.prototype.hasOwnProperty, n = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, p = { key: true, ref: true, __self: true, __source: true };
function q(c, a, g) {
  var b, d = {}, e = null, h = null;
  void 0 !== g && (e = "" + g);
  void 0 !== a.key && (e = "" + a.key);
  void 0 !== a.ref && (h = a.ref);
  for (b in a)
    m.call(a, b) && !p.hasOwnProperty(b) && (d[b] = a[b]);
  if (c && c.defaultProps)
    for (b in a = c.defaultProps, a)
      void 0 === d[b] && (d[b] = a[b]);
  return { $$typeof: k, type: c, key: e, ref: h, props: d, _owner: n.current };
}
reactJsxRuntime_production_min.Fragment = l;
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const LoadingIndicator = (props) => {
  const {
    fillColor,
    size,
    position,
    hideBackgorund,
    blur = false,
    color
  } = props;
  const [transformSize, setTransformSize] = useState();
  const [transformPositionTop, setTransformPositionTop] = useState();
  const [transformPositionLeft, setTransformPositionLeft] = useState();
  useEffect(() => {
    setTransformSize(setSize);
    setTransformPositionTop(setPositionTop);
    setTransformPositionLeft(setPositionLeft);
  });
  const setSize = useCallback(() => {
    switch (size) {
      case "xs":
        return "0.25rem";
      case "sm":
        return "1.25rem";
      case "md":
        return "2.5rem";
      case "lg":
        return "8rem";
      case "xl":
        return "15rem";
      default:
        return "2.5rem";
    }
  }, [size]);
  const setPositionTop = useCallback(() => {
    switch (position) {
      case "bottom":
        return "90%";
      case "top":
        return "10%";
      case "left":
        return "50%";
      case "right":
        return "50%";
      case "bottom-left":
        return "90%";
      case "bottom-right":
        return "90%";
      case "top-left":
        return "10%";
      case "top-right":
        return "10%";
      case "center":
        return "50%";
      default:
        return "50%";
    }
  }, [position]);
  const setPositionLeft = useCallback(() => {
    switch (position) {
      case "bottom":
        return "50%";
      case "top":
        return "50%";
      case "left":
        return "10%";
      case "right":
        return "90%";
      case "bottom-left":
        return "90%";
      case "bottom-right":
        return "90%";
      case "top-left":
        return "10%";
      case "top-right":
        return "90%";
      case "center":
        return "50%";
      default:
        return "50%";
    }
  }, [position]);
  const rotationBuilder = () => {
    const rotation = keyframes`
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(360deg);

    }
  `;
    return rotation;
  };
  const LoadingIndicator2 = styled.div`
    animation: ${rotationBuilder()} 2s linear infinite;
    width: ${transformSize};
    height: ${transformSize};
    top: ${transformPositionTop};
    left: ${transformPositionLeft};
    opacity: ${hideBackgorund ? "0" : "100"};
    border: 16px solid ${color != null ? color : "#f3f3f3"};
    border-top: 16px solid ${fillColor != null ? fillColor : "#3498db"};
    position: fixed;
    border-radius: 50%;
  `;
  const LoadingIndicatorContainer = styled.div`
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
  `;
  const LoadingIndicatorContainerBlur = styled.div`
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
    backdrop-filter: blur(0.2rem);
  `;
  return /* @__PURE__ */ jsx("div", {
    children: blur ? /* @__PURE__ */ jsx(LoadingIndicatorContainerBlur, {
      children: /* @__PURE__ */ jsx(LoadingIndicator2, {})
    }) : /* @__PURE__ */ jsx(LoadingIndicatorContainer, {
      children: /* @__PURE__ */ jsx(LoadingIndicator2, {})
    })
  });
};
export { LoadingIndicator };
