import { FC } from "react";
declare const LoadingIndicatorSizes: ["xs", "sm", "md", "lg", "xl"];
export declare type LoadingIndicatorSize = typeof LoadingIndicatorSizes[number];
declare const LoadingIndicatorPositions: [
    "top",
    "bottom",
    "left",
    "right",
    "bottom-left",
    "bottom-right",
    "top-right",
    "top-left",
    "center"
];
export declare type LoadingIndicatorPosition = typeof LoadingIndicatorPositions[number];
export interface ILoadingIndicatorProps {
    size?: LoadingIndicatorSize;
    fillColor?: string;
    color?: string;
    position?: LoadingIndicatorPosition;
    hideBackgorund?: boolean;
    blur?: boolean;
}
declare const LoadingIndicator: FC<ILoadingIndicatorProps>;
export default LoadingIndicator;
